VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmPEFIleInfo 
   Caption         =   "rpiPEInfo"
   ClientHeight    =   9204
   ClientLeft      =   84
   ClientTop       =   660
   ClientWidth     =   12360
   Icon            =   "PEFileInfo.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   9204
   ScaleWidth      =   12360
   StartUpPosition =   2  'CenterScreen
   Begin MSComctlLib.ListView lvExports 
      Height          =   8832
      Left            =   4860
      TabIndex        =   10
      Top             =   240
      Width           =   3192
      _ExtentX        =   5630
      _ExtentY        =   15579
      Sorted          =   -1  'True
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin VB.TextBox txtDetails 
      Height          =   8412
      Left            =   2160
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   9
      Top             =   600
      Width           =   2652
   End
   Begin MSComctlLib.ListView lvImports 
      Height          =   8832
      Left            =   8100
      TabIndex        =   8
      Top             =   240
      Width           =   4212
      _ExtentX        =   7430
      _ExtentY        =   15579
      View            =   3
      Sorted          =   -1  'True
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin VB.CheckBox chkDLLsOnly 
      Caption         =   "&DLLs Only"
      Height          =   192
      Left            =   0
      TabIndex        =   4
      Top             =   3360
      Width           =   1032
   End
   Begin VB.FileListBox File1 
      Height          =   5448
      Left            =   0
      TabIndex        =   2
      Top             =   3600
      Width           =   2112
   End
   Begin VB.DirListBox Dir1 
      Height          =   2664
      Left            =   0
      TabIndex        =   1
      Top             =   660
      Width           =   2112
   End
   Begin VB.DriveListBox Drive1 
      Height          =   288
      Left            =   0
      TabIndex        =   0
      Top             =   360
      Width           =   2112
   End
   Begin VB.TextBox txtVersion 
      BackColor       =   &H00C0C0C0&
      Height          =   312
      Left            =   0
      Locked          =   -1  'True
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   0
      Width           =   4752
   End
   Begin MSComDlg.CommonDialog cdialog 
      Left            =   6240
      Top             =   -60
      _ExtentX        =   677
      _ExtentY        =   677
      _Version        =   393216
      DialogTitle     =   "Select DLL"
   End
   Begin VB.Label lblImports 
      AutoSize        =   -1  'True
      Caption         =   "Imports"
      Height          =   192
      Left            =   8100
      TabIndex        =   7
      Top             =   0
      Width           =   528
   End
   Begin VB.Label lblDetails 
      AutoSize        =   -1  'True
      Caption         =   "Details"
      Height          =   192
      Left            =   2160
      TabIndex        =   6
      Top             =   360
      Width           =   504
   End
   Begin VB.Label lblExports 
      AutoSize        =   -1  'True
      Caption         =   "Exports"
      Height          =   192
      Left            =   4920
      TabIndex        =   5
      Top             =   0
      Width           =   540
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuCopyToClip 
         Caption         =   "&Copy To Clipboard"
      End
      Begin VB.Menu mnuLine1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "frmPEFIleInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Sub GetExports(sFile As String)

Dim i As Integer, j As Integer
Dim lret As Long
Dim baseaddr As Long
Dim rvaExportDirTable As Long
Dim vaExportDirTable As Long
Dim cNames As Long
Dim sName As String

' --------
' Pointers
' --------
' Pointer to Export Name Pointer Table
Dim ExportNamePointerTableVA As Long
' Pointer to next address
Dim pNextAddress As Long
' Next address
Dim lNextAddress As Long

' ----------
' Structures
' ----------
' Loaded image
Dim loadimage As LOADED_IMAGE
' PE File header
Dim peheader As IMAGE_PE_FILE_HEADER
' Export directory
Dim exportdir As IMAGE_EXPORT_DIRECTORY_TABLE
  
' ----------
' Load image
' ----------
lret = MapAndLoad(sFile, "", loadimage, True, True)

' Check for error and display
If lret = 0 Then
   txtVersion = "MapAndLoad failed for exports." & GetAPIErrorText(Err.LastDllError)
   Exit Sub
End If

' ------------
' Base address
' ------------
baseaddr = loadimage.MappedAddress

' -----------------------------
' Copy the IMAGE_PE_FILE_HEADER
' -----------------------------
' at address loadimage.pFileheader to
' peheader variable so we can access its members
CopyMemory ByVal VarPtr(peheader), ByVal loadimage.pFileHeader, 256

' -------------------------------
' Get the VA of export directory
' -------------------------------
rvaExportDirTable = peheader.OptionalHeader.DataDirectory(IMAGE_DIRECTORY_ENTRY_EXPORT).RVA
If rvaExportDirTable = 0 Then
   txtVersion = "No export directory."
   Exit Sub
End If

' Call RvaToVa to get VA from RVA
vaExportDirTable = ImageRvaToVa(loadimage.pFileHeader, loadimage.MappedAddress, rvaExportDirTable, 0&)

'''''Debug.Print "MappedAddr:" & Hex(loadimage.MappedAddress)
'''''Debug.Print "rvaExportDirTable:" & Hex(rvaExportDirTable)
'''''Debug.Print "VA:" & Hex(vaExportDirTable)
'''''Debug.Print loadimage.MappedAddress + rvaExportDirTable - vaExportDirTable
'''''Debug.Print

' ------------------------------------
' Get Export Directory table structure
' ------------------------------------
CopyMemory ByVal VarPtr(exportdir), ByVal vaExportDirTable, LenB(exportdir)

' ----------------------
' Number of export names
' ----------------------
cNames = exportdir.NumberOfNames
lblExports.Caption = "Exports: " & cNames

' -------------------------------
' Get VA of Export Name Pointer Table
' -------------------------------
' exportdir.ExportNamePointerTableRVA is pointer to Export Name Pointer Table
' Convert RVA to VA
ExportNamePointerTableVA = ImageRvaToVa(loadimage.pFileHeader, loadimage.MappedAddress, exportdir.ExportNamePointerTableRVA, 0&)

' --------------------
' Collect Export Names
' --------------------
' Start at the beginning of names
pNextAddress = ExportNamePointerTableVA

' Get the next address (to export name)
VBGetTarget lNextAddress, pNextAddress, 4
lvExports.ListItems.Clear

For i = 0 To cNames - 1

   ' Convert address of this name from RVA to VA
   lNextAddress = ImageRvaToVa(loadimage.pFileHeader, loadimage.MappedAddress, lNextAddress, 0&)
   
   ' Convert ANSI string to BSTR
   sName = LPSTRtoBSTR(lNextAddress)
   lvExports.ListItems.Add , , sName

   ' Point to next address in table
   pNextAddress = pNextAddress + 4

   ' Get the address
   VBGetTarget lNextAddress, pNextAddress, 4

Next

UnloadImage:

' ------------
' Unload image
' ------------
lret = UnMapAndLoad(loadimage)
If lret = 0 Then
   txtVersion = "UnMapAndLoad failed for exports." & GetAPIErrorText(Err.LastDllError)
End If

End Sub
Sub GetImports(sFile As String)

Dim i As Integer, j As Integer
Dim lret As Long
Dim baseaddr As Long
Dim rvaImportDirTable As Long
Dim vaImportDirTable As Long

Dim cNames As Long
Dim sDLLName As String
Dim sFunctionName As String

Dim li As ListItem

' --------
' Pointers
' --------
Dim pImportDirTableEntry As Long
Dim LookupTableRVA As Long
Dim LookupTableVA As Long
Dim pLookupTableEntry As Long
Dim LookupTableEntry As Long
Dim pImportFunctionName As Long
Dim DLLNameRVA As Long
Dim DLLNameVA As Long

' ----------
' Structures
' ----------
' Loaded image
Dim loadimage As LOADED_IMAGE
' PE File header
Dim peheader As IMAGE_PE_FILE_HEADER
  
' ----------
' Load image
' ----------
lret = MapAndLoad(sFile, "", loadimage, True, True)

' Check for error and display
If lret = 0 Then
   txtVersion = "MapAndLoad failed for imports." & GetAPIErrorText(Err.LastDllError)
   Exit Sub
End If

' ------------
' Base address
' ------------
baseaddr = loadimage.MappedAddress

' -----------------------------
' Copy the IMAGE_PE_FILE_HEADER
' -----------------------------
' at address loadimage.pFileheader to
' peheader variable so we can access its members
CopyMemory ByVal VarPtr(peheader), ByVal loadimage.pFileHeader, 256

' -------------------------------
' Get the VA of import directory
' -------------------------------
rvaImportDirTable = peheader.OptionalHeader.DataDirectory(IMAGE_DIRECTORY_ENTRY_IMPORT).RVA
If rvaImportDirTable = 0 Then
   txtVersion = "No import directory."
   Exit Sub
End If

' Call RvaToVa to get VA from RVA
vaImportDirTable = ImageRvaToVa(loadimage.pFileHeader, loadimage.MappedAddress, rvaImportDirTable, 0&)

' -----------------------------------------------
' Cycle through Import Dir Table until null entry
' -----------------------------------------------
lvImports.ListItems.Clear
cNames = 0

' Start with first entry in Import Dir Table
pImportDirTableEntry = vaImportDirTable

Do
   VBGetTarget LookupTableRVA, pImportDirTableEntry, 4
   VBGetTarget DLLNameRVA, pImportDirTableEntry + 12, 4
   If LookupTableRVA = 0 And DLLNameRVA = 0 Then Exit Do
   ' Convert to VA
   LookupTableVA = ImageRvaToVa(loadimage.pFileHeader, loadimage.MappedAddress, LookupTableRVA, 0&)
   DLLNameVA = ImageRvaToVa(loadimage.pFileHeader, loadimage.MappedAddress, DLLNameRVA, 0&)
  
   sDLLName = LPSTRtoBSTR(DLLNameVA)
   
   ' Now get all imported functions from this DLL
   pLookupTableEntry = LookupTableVA
   
   Do
      VBGetTarget LookupTableEntry, pLookupTableEntry, 4
      If LookupTableEntry = 0 Then Exit Do
      
      ' Check most significant bit
      ' If 0 then skip since it is by ordinal not by name
      If LookupTableEntry >= 0 Then
         
         cNames = cNames + 1
         ' Mask MSB
         LookupTableEntry = LookupTableEntry And &H7FFFFFFF
      
         ' Convert RVA to VA to get address of function name
         pImportFunctionName = ImageRvaToVa(loadimage.pFileHeader, loadimage.MappedAddress, LookupTableEntry, 0&)
         
         ' Name is at offset 2 in entry
         sFunctionName = LPSTRtoBSTR(pImportFunctionName + 2)

         Set li = lvImports.ListItems.Add()
         li.Text = sFunctionName
         li.ListSubItems.Add , , sDLLName
      
      End If
      
      ' Next entry
      pLookupTableEntry = pLookupTableEntry + 4
   Loop

   ' Next Import Directory Table entry
   pImportDirTableEntry = pImportDirTableEntry + 20
   
Loop

lblImports = "Imports: " & cNames

UnloadImage:

' ------------
' Unload image
' ------------
lret = UnMapAndLoad(loadimage)
If lret = 0 Then
   txtVersion = "UnMapAndLoad failed for imports." & GetAPIErrorText(Err.LastDllError)
End If

End Sub

Private Sub chkDLLsOnly_Click()
   If chkDLLsOnly = 1 Then
      File1.Pattern = "*.dll"
   Else
      File1.Pattern = "*.*"
   End If
End Sub

Private Sub Dir1_Change()
File1.Path = Dir1.Path
End Sub

Private Sub Drive1_Change()

On Error GoTo ERR_Drive1_Change

Dir1.Path = Drive1.Drive
File1.Path = Dir1.Path

Exit Sub
ERR_Drive1_Change:
   MsgBox "Error in Drive1_Change. " & Err.Number & ": " & Err.Description

End Sub

Private Sub File1_Click()

Dim sFile As String

sFile = File1.Path
If Right(sFile, 1) <> "\" Then sFile = sFile & "\"
sFile = sFile & File1.FileName

' Caption
Me.Caption = "rpiPEInfo: " & sFile

' Clear all controls
ClearAll
GetVersionInfo sFile
If GetPEFileChars Then
   GetExports sFile
   GetImports sFile
End If

End Sub
Sub ClearAll()

lvExports.ListItems.Clear
lvImports.ListItems.Clear
txtVersion = ""
txtDetails = ""

End Sub

Function GetPEFileChars() As Boolean

' Returns false if not a PE file (no PE signature)
' Otherwise opens the file and reads the characteristics flag
' which follows the PE file signature
' Also gets preferred base address.

On Error GoTo ERR_GetPEFileChars

Dim bSigOffset As Byte
Dim lCOFFOffset As Long
Dim lOptHeaderOffset As Long
Dim lSectionTableOffset As Long

Dim lBase As Long
Dim iFlag As Integer
Dim lDataDirEntryCount As Long

Dim lSignature As Long

Dim bSectionName(1 To 8) As Byte
Dim sSectionName As String

Dim i As Integer, j As Integer

Dim sText As String
Dim sFile As String
Dim fr As Integer
fr = FreeFile

txtDetails = txtDetails & vbCrLf & "FILE CHARACTERISTICS:"

' Get path/name of file
sFile = File1.Path
If Right(sFile, 1) <> "\" Then sFile = sFile & "\"
sFile = sFile & File1.FileName

Open sFile For Binary Access Read As #fr

'Check for PE file signature
Get #fr, &H3C + 1, bSigOffset
Get #fr, bSigOffset + 1, lSignature
If Not lSignature = &H4550 Then     ' PE\0\0 backwards in memory
   Close fr
   txtDetails = txtDetails & vbCrLf & "   No PE signature"
   Exit Function
End If

' -------------------
' Some table offsets
' -------------------
' COFF offset
lCOFFOffset = CLng(bSigOffset) + 4

' Optional Header offset
lOptHeaderOffset = lCOFFOffset + 20

' -------------------------------
' Get some values at these offsets
' -------------------------------
' Characteristics of file
Get #fr, lCOFFOffset + 18 + 1, iFlag
sText = GetPEChar(iFlag)

' Preferred image base address
Get #fr, lOptHeaderOffset + 28 + 1, lBase
sText = sText & vbCrLf & "Base Address: &H" & Hex(lBase)

' -------------------
' Section table names
' -------------------
' Number of data directory entries
Get #fr, lOptHeaderOffset + 92 + 1, lDataDirEntryCount

' Use this to find offset of section table
lSectionTableOffset = lOptHeaderOffset + 96 + lDataDirEntryCount * 8

' Get section table names
If lDataDirEntryCount > 0 Then
   sText = sText & vbCrLf & "SECTION NAMES:"
   For j = 1 To lDataDirEntryCount
      ' Be careful here is 8-character names are NOT null terminated!
      ' Thus, we use an 8-byte buffer
      For i = 1 To 8
         Get #fr, lSectionTableOffset + i + (j - 1) * 40, bSectionName(i)
      Next
      sSectionName = StrConv(bSectionName, vbUnicode)
      sSectionName = Trim(Replace(sSectionName, Chr(0), " "))
      If sSectionName <> "" Then
         sText = sText & vbCrLf & "   " & sSectionName
      End If
   
   Next

End If

Close fr

' -------
' Display
' -------
txtDetails = txtDetails & vbCrLf & sText
GetPEFileChars = True

Exit Function
ERR_GetPEFileChars:
   txtDetails = "Error " & Err.Number & ": " & Err.Description

End Function
Private Sub Form_Load()

Dim sDir As String
Dim lret As Long

lvImports.ColumnHeaders.Add , , "Function", lvImports.Width / 2
lvImports.ColumnHeaders.Add , , "DLL", lvImports.Width / 2, lvwColumnCenter
lvImports.View = lvwReport

lvExports.ColumnHeaders.Add , , "Function", lvExports.Width
lvExports.View = lvwReport

sDir = String(MAX_PATH, 0)
lret = GetSystemDirectory(sDir, MAX_PATH)
Drive1.Drive = sDir
Dir1.Path = sDir
chkDLLsOnly = 1

End Sub


Sub GetVersionInfo(sFQName)

Dim lFileVerInfoSize As Long
Dim lpHandle As Long
Dim lret As Long
Dim lpData As Long
Dim bData() As Byte
Dim sVersionValue As String
Dim pValue As Long
Dim ValueSize As Long
Dim ff As VS_FIXEDFILEINFO
Dim sFileVersion As String
Dim sProductVersion As String
Dim lUpper As Long
Dim lLower As Long
Dim sVersion As String
Dim i As Integer
Dim sCompany As String

' --------------------------
' Get file version info size
' --------------------------
lFileVerInfoSize = GetFileVersionInfoSize(sFQName, lpHandle)
If lFileVerInfoSize = 0 Then
   txtVersion = GetAPIErrorText(Err.LastDllError)
   Exit Sub
End If

' ----------------------------
' Get file version info buffer
' ----------------------------
ReDim bData(1 To lFileVerInfoSize)

lret = GetFileVersionInfo(sFQName, lpHandle, lFileVerInfoSize, bData(1))
If lret = 0 Then
   txtVersion = GetAPIErrorText(Err.LastDllError)
   Exit Sub
End If

' ------------------------------
' Get version info -- root block
' ------------------------------
sVersionValue = "\"
lret = VerQueryValue(bData(1), sVersionValue, pValue, ValueSize)  ' pValue is passed ByRef
If lret = 0 Then Exit Sub

CopyMemory ByVal VarPtr(ff), ByVal pValue, ValueSize
' OR
''CopyMemory ff, ByVal ppValue, ValueSize

' ---------------------------------
' Prepare file version (both halfs)
' ---------------------------------
lUpper = CLng(ff.dwFileVersionMS / &H10000)
lLower = CLng(ff.dwFileVersionMS And &HFFFF&)
sFileVersion = CStr(lUpper) & "." & CStr(lLower)

lUpper = CLng(ff.dwFileVersionLS / &H10000)
lLower = CLng(ff.dwFileVersionLS And &HFFFF&)
sFileVersion = sFileVersion & "." & CStr(lUpper) & "." & CStr(lLower)

' Prepare product version (both halfs)
lUpper = CLng(ff.dwProductVersionMS / &H10000)
lLower = CLng(ff.dwProductVersionMS And &HFFFF&)
sProductVersion = CStr(lUpper) & "." & CStr(lLower)

lUpper = CLng(ff.dwProductVersionLS / &H10000)
lLower = CLng(ff.dwProductVersionLS And &HFFFF&)
sProductVersion = sProductVersion & "." & CStr(lUpper) & "." & CStr(lLower)

sVersion = "File Version " & sFileVersion & vbCrLf & "Product Version " & sProductVersion

''dwFileDateXX seems always to be 0!
''sVersion = sVersion & "  TimeDateStamp: " & Hex(ff.dwFileDateMS) & Hex(ff.dwFileDateLS)
sVersion = sVersion & vbCrLf & "File Date: " & FileDateTime(sFQName)

' --------------------------------
' Get version info -- company name
' --------------------------------
' Get languages
Dim cLangs As Long
Dim iLangID As Integer
Dim iCodePageID As Integer
Dim sLangID As String
Dim sCodePageID As String
sVersionValue = "\VarFileInfo\Translation"
lret = VerQueryValue(bData(1), sVersionValue, pValue, ValueSize)  ' pValue is passed ByRef
If lret <> 0 Then
   cLangs = ValueSize / 4
   For i = 0 To cLangs - 1
      VBGetTarget iLangID, pValue + 4 * i, 2
      VBGetTarget iCodePageID, pValue + 4 * i + 2, 2
      If iLangID = LANG_ENGLISH Then Exit For
   Next
Else
   ' Use English anyway!!
   iLangID = &H409
   iCodePageID = &H4B0
End If

' Format these as 4-character hex strings
sLangID = Hex$(iLangID)
Do While Len(sLangID) < 4
   sLangID = "0" & sLangID
Loop
sCodePageID = Hex$(iCodePageID)
Do While Len(sCodePageID) < 4
   sCodePageID = "0" & sCodePageID
Loop

' Use English language
sVersionValue = "\StringFileInfo\" & sLangID & sCodePageID & "\CompanyName"
lret = VerQueryValue(bData(1), sVersionValue, pValue, ValueSize)  ' pValue is passed ByRef
If lret = 0 Then
   txtVersion = ""
   Exit Sub
End If
sCompany = ""
For i = 1 To ValueSize
   sCompany = sCompany & Chr(bData(pValue - VarPtr(bData(1)) + i))
Next

sVersion = sVersion & vbCrLf & "Company: " & sCompany

' ----------
' Display it
' ----------
txtDetails = sVersion

End Sub

Private Sub lvExports_ColumnClick(ByVal ColumnHeader As MSComctlLib.ColumnHeader)
lvExports.SortKey = ColumnHeader.Index - 1
End Sub

Private Sub lvImports_ColumnClick(ByVal ColumnHeader As MSComctlLib.ColumnHeader)
lvImports.SortKey = ColumnHeader.Index - 1
End Sub

Private Sub mnuCopyToClip_Click()
   CopyToClip
End Sub

Sub CopyToClip()

' Copy to clipboard

Dim s As String, i As Integer

s = Me.Caption

s = s & vbCrLf & "**********" & vbCrLf

s = s & txtDetails

s = s & vbCrLf & "**********" & vbCrLf

s = s & lblExports.Caption & vbCrLf
For i = 1 To lvExports.ListItems.Count
   s = s & lvExports.ListItems(i) & vbCrLf
Next

s = s & "**********" & vbCrLf

s = s & lblImports.Caption & vbCrLf
For i = 1 To lvImports.ListItems.Count
   s = s & lvImports.ListItems(i).Text & " (" & lvImports.ListItems(i).ListSubItems(1).Text & ")" & vbCrLf
Next

Clipboard.Clear
Clipboard.SetText s

MsgBox "Exports copied to clipboard.", vbInformation

End Sub

Private Sub mnuExit_Click()
Unload Me
End Sub

